summaryrefslogtreecommitdiff
path: root/net-irc
diff options
context:
space:
mode:
authorV3n3RiX <venerix@rogentos.ro>2016-04-10 14:47:29 +0100
committerV3n3RiX <venerix@rogentos.ro>2016-04-10 14:47:29 +0100
commitb5da06faa9fb1a4fc5e5abbf507e0fbb02df6b9b (patch)
treeafa07f011dce3d55d3974243b029d9f236c015e3 /net-irc
parentd7bdaa788dc55ae77989f17d612fdbbf4b119c9a (diff)
import quassel, make it depend on our splitted libdbusmenu
Diffstat (limited to 'net-irc')
-rw-r--r--net-irc/quassel/Manifest2
-rw-r--r--net-irc/quassel/files/quassel-0.12.2-CVE-2015-8547.patch22
-rw-r--r--net-irc/quassel/files/quassel-0.12.2-qt55.patch53
-rw-r--r--net-irc/quassel/files/quassel.logrotate9
-rw-r--r--net-irc/quassel/files/quasselcore.conf22
-rw-r--r--net-irc/quassel/files/quasselcore.init63
-rw-r--r--net-irc/quassel/files/quasselcore.service11
-rw-r--r--net-irc/quassel/quassel-0.12.2-r3.ebuild223
8 files changed, 405 insertions, 0 deletions
diff --git a/net-irc/quassel/Manifest b/net-irc/quassel/Manifest
new file mode 100644
index 00000000..3962e34c
--- /dev/null
+++ b/net-irc/quassel/Manifest
@@ -0,0 +1,2 @@
+DIST quassel-0.12.2.tar.bz2 3681838 SHA256 6bd6f79ecb88fb857bea7e89c767a3bd0f413ff01bae9298dd2e563478947897 SHA512 0c907982af0ba11af6ba5d075850149dc4d4df0c759a736dfaccdc01778958bd9b0137515c2d78a72a1b5aef6600cea47505de6ee905d83a51cf4e67d132911d WHIRLPOOL 947c47ab6a5db73fdda7d5e5fc3f618030e9c2cfd78f4f423b32332e6514b5c3b8d24423a6be8ee8bf81e2e4a973aa29578e776dba5e8f7ad947acbcb7aef497
+DIST quassel-0.12.3.tar.bz2 3687078 SHA256 4d3ee91b85cce3d8df62faf55ad35bebd6fc45085ed6248b8a41d2858de3d434 SHA512 0cb5486c4a992cb4e5e84ec2cc15f11ac6e324fa7b3a4a0ddc1edd090adabcb30f8856b1f2f348bec34fdfa33bcfa0e8e14fb45898d11d954f501bb3ee4c8aa4 WHIRLPOOL 482c2afee0e24dee2f3e80cacb47c7f7642851c4f417723a73258579824331a265c56b5777bc79c47bd3af6a6747d33a00bb539894f64081165d75cb19b351cc
diff --git a/net-irc/quassel/files/quassel-0.12.2-CVE-2015-8547.patch b/net-irc/quassel/files/quassel-0.12.2-CVE-2015-8547.patch
new file mode 100644
index 00000000..cf838c7c
--- /dev/null
+++ b/net-irc/quassel/files/quassel-0.12.2-CVE-2015-8547.patch
@@ -0,0 +1,22 @@
+From 476aaa050f26d6a31494631d172724409e4c569b Mon Sep 17 00:00:00 2001
+From: =?UTF-8?q?Konstantin=20Bl=C3=A4si?= <kblaesi@gmail.com>
+Date: Wed, 21 Oct 2015 03:26:02 +0200
+Subject: [PATCH] Fixes a crash of the core when executing "/op *" in a query.
+
+---
+ src/core/coreuserinputhandler.cpp | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/core/coreuserinputhandler.cpp b/src/core/coreuserinputhandler.cpp
+index 7887a92..73aac48 100644
+--- a/src/core/coreuserinputhandler.cpp
++++ b/src/core/coreuserinputhandler.cpp
+@@ -228,7 +228,7 @@ void CoreUserInputHandler::doMode(const BufferInfo &bufferInfo, const QChar& add
+ if (!isNumber || maxModes == 0) maxModes = 1;
+
+ QStringList nickList;
+- if (nicks == "*") { // All users in channel
++ if (nicks == "*" && bufferInfo.type() == BufferInfo::ChannelBuffer) { // All users in channel
+ const QList<IrcUser*> users = network()->ircChannel(bufferInfo.bufferName())->ircUsers();
+ foreach(IrcUser *user, users) {
+ if ((addOrRemove == '+' && !network()->ircChannel(bufferInfo.bufferName())->userModes(user).contains(mode))
diff --git a/net-irc/quassel/files/quassel-0.12.2-qt55.patch b/net-irc/quassel/files/quassel-0.12.2-qt55.patch
new file mode 100644
index 00000000..3bf8989e
--- /dev/null
+++ b/net-irc/quassel/files/quassel-0.12.2-qt55.patch
@@ -0,0 +1,53 @@
+From 0df317e85ab3d1d80135995d3b5d7f5341fef6e4 Mon Sep 17 00:00:00 2001
+From: Armin K <krejzi@email.com>
+Date: Sat, 2 May 2015 23:04:53 +0200
+Subject: [PATCH] Fix build with Qt-5.5
+
+http://code.qt.io/cgit/qt/qtbase.git/commit/?id=ebef2ad1360c80ad62de5f4a1c4e7e4051725c1c
+---
+ src/client/treemodel.cpp | 5 ++---
+ src/common/peer.h | 1 +
+ 2 files changed, 3 insertions(+), 3 deletions(-)
+
+diff --git a/src/client/treemodel.cpp b/src/client/treemodel.cpp
+index f599803..fd47bc0 100644
+--- a/src/client/treemodel.cpp
++++ b/src/client/treemodel.cpp
+@@ -556,10 +556,9 @@ void TreeModel::endAppendChilds()
+ ChildStatus cs = _childStatus;
+ #ifndef QT_NO_DEBUG
+ QModelIndex parent = indexByItem(parentItem);
+-#endif
+ Q_ASSERT(cs.parent == parent);
+ Q_ASSERT(rowCount(parent) == cs.childCount + cs.end - cs.start + 1);
+-
++#endif
+ _aboutToRemoveOrInsert = false;
+ for (int i = cs.start; i <= cs.end; i++) {
+ connectItem(parentItem->child(i));
+@@ -605,9 +604,9 @@ void TreeModel::endRemoveChilds()
+ #ifndef QT_NO_DEBUG
+ ChildStatus cs = _childStatus;
+ QModelIndex parent = indexByItem(parentItem);
+-#endif
+ Q_ASSERT(cs.parent == parent);
+ Q_ASSERT(rowCount(parent) == cs.childCount - cs.end + cs.start - 1);
++#endif
+ _aboutToRemoveOrInsert = false;
+
+ endRemoveRows();
+diff --git a/src/common/peer.h b/src/common/peer.h
+index 02eb3c0..79204b4 100644
+--- a/src/common/peer.h
++++ b/src/common/peer.h
+@@ -22,6 +22,7 @@
+ #define PEER_H
+
+ #include <QAbstractSocket>
++#include <QDataStream>
+ #include <QPointer>
+
+ #include "authhandler.h"
+--
+2.4.0
+
diff --git a/net-irc/quassel/files/quassel.logrotate b/net-irc/quassel/files/quassel.logrotate
new file mode 100644
index 00000000..8e720835
--- /dev/null
+++ b/net-irc/quassel/files/quassel.logrotate
@@ -0,0 +1,9 @@
+/var/log/quassel.log {
+ compress
+ rotate 4
+ weekly
+ delaycompress
+ copytruncate
+ missingok
+ notifempty
+}
diff --git a/net-irc/quassel/files/quasselcore.conf b/net-irc/quassel/files/quasselcore.conf
new file mode 100644
index 00000000..4a000714
--- /dev/null
+++ b/net-irc/quassel/files/quasselcore.conf
@@ -0,0 +1,22 @@
+# Copyright 1999-2015 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+# Loglevel Debug|Info|Warning|Error. Default is: Info
+# The logfile is located at /var/log/quassel.log.
+#LOGLEVEL="Info"
+
+# The address(es) quasselcore will listen on. Default is 0.0.0.0
+#LISTEN="0.0.0.0"
+
+# The port quasselcore will listen at. Default is: 4242
+#PORT="4242"
+
+# User we want our daemon to run under.
+#QUASSEL_USER="quassel"
+
+# Directory we store all quasselcore content.
+#CONFIGDIR="/var/lib/quassel"
+
+# File quasselcore will log all its events into.
+#LOGFILE="/var/log/quassel.log"
diff --git a/net-irc/quassel/files/quasselcore.init b/net-irc/quassel/files/quasselcore.init
new file mode 100644
index 00000000..1cbbc838
--- /dev/null
+++ b/net-irc/quassel/files/quasselcore.init
@@ -0,0 +1,63 @@
+#!/sbin/runscript
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+depend() {
+ need localmount net
+ after bootmisc postgres
+}
+
+CORE="$(which quasselcore)"
+PID="/var/run/quassel.pid"
+LOGFILE=${LOGFILE:-"/var/log/quassel.log"}
+CONFIGDIR=${CONFIGDIR:-"/var/lib/quassel"}
+QUASSEL_USER=${QUASSEL_USER:-"quassel"}
+
+checkconfig() {
+ # set defaults
+ LOGLEVEL=${LOGLEVEL:-"Info"}
+
+ # check config folder
+ if [ ! -d "${CONFIGDIR}" ]; then
+ mkdir "${CONFIGDIR}" || return 1
+ fi
+ # permissions always changed just to avoid runtime issues
+ chown -R "${QUASSEL_USER}":"${QUASSEL_USER}" "${CONFIGDIR}" || return 1
+
+ # check log file
+ if [ ! -e "${LOGFILE}" ]; then
+ touch "${LOGFILE}" || return 1
+ fi
+ # permissions always changed just to avoid runtime issues
+ chown "${QUASSEL_USER}":"${QUASSEL_USER}" "${LOGFILE}" || return 1
+}
+
+start() {
+ checkconfig || return 1
+
+ ebegin "Starting Quassel Core"
+
+ if [ -n "${RC_UNAME}" ]; then
+ # running on baselayout-2/openrc
+ start-stop-daemon --start --user "${QUASSEL_USER}" --background --make-pidfile \
+ --pidfile "${PID}" \
+ --exec "${CORE}" -- --logfile="${LOGFILE}" --loglevel="${LOGLEVEL}" \
+ ${LISTEN:+--listen="${LISTEN}"} ${PORT:+--port="${PORT}"} \
+ --configdir="${CONFIGDIR}"
+ else
+ # running on baselayout-1
+ start-stop-daemon --start --chuid "${QUASSEL_USER}" --background --make-pidfile \
+ --pidfile "${PID}" --env HOME="${CONFIGDIR}" \
+ --exec "${CORE}" -- --logfile="${LOGFILE}" --loglevel="${LOGLEVEL}" \
+ ${LISTEN:+--listen="${LISTEN}"} ${PORT:+--port="${PORT}"} \
+ --configdir="${CONFIGDIR}"
+ fi
+ eend $?
+}
+
+stop() {
+ ebegin "Stopping Quassel Core"
+ start-stop-daemon --stop --pidfile "${PID}" --exec "${CORE}"
+ eend $?
+}
diff --git a/net-irc/quassel/files/quasselcore.service b/net-irc/quassel/files/quasselcore.service
new file mode 100644
index 00000000..f5b49ab0
--- /dev/null
+++ b/net-irc/quassel/files/quasselcore.service
@@ -0,0 +1,11 @@
+[Unit]
+Description=Quassel Core
+After=network.target
+
+[Service]
+User=quassel
+Group=quassel
+ExecStart=/usr/bin/quasselcore --configdir=/var/lib/quassel
+
+[Install]
+WantedBy=multi-user.target
diff --git a/net-irc/quassel/quassel-0.12.2-r3.ebuild b/net-irc/quassel/quassel-0.12.2-r3.ebuild
new file mode 100644
index 00000000..dbc06395
--- /dev/null
+++ b/net-irc/quassel/quassel-0.12.2-r3.ebuild
@@ -0,0 +1,223 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+inherit cmake-utils eutils pax-utils systemd user versionator
+
+EGIT_REPO_URI="git://git.quassel-irc.org/quassel"
+[[ "${PV}" == "9999" ]] && inherit git-r3
+
+DESCRIPTION="Qt/KDE IRC client supporting a remote daemon for 24/7 connectivity"
+HOMEPAGE="http://quassel-irc.org/"
+[[ "${PV}" == "9999" ]] || SRC_URI="http://quassel-irc.org/pub/${P}.tar.bz2"
+
+LICENSE="GPL-3"
+KEYWORDS="amd64 ~arm ppc x86 ~amd64-linux ~sparc-solaris"
+SLOT="0"
+IUSE="ayatana crypt dbus debug kde monolithic phonon postgres qt5 +server +ssl syslog webkit X"
+
+SERVER_RDEPEND="
+ qt5? (
+ dev-qt/qtscript:5
+ crypt? ( app-crypt/qca:2[openssl,qt5] )
+ postgres? ( dev-qt/qtsql:5[postgres] )
+ !postgres? ( dev-qt/qtsql:5[sqlite] dev-db/sqlite:3[threadsafe(+),-secure-delete] )
+ )
+ !qt5? (
+ dev-qt/qtscript:4
+ crypt? ( app-crypt/qca:2[openssl,qt4(+)] )
+ postgres? ( dev-qt/qtsql:4[postgres] )
+ !postgres? ( dev-qt/qtsql:4[sqlite] dev-db/sqlite:3[threadsafe(+),-secure-delete] )
+ )
+ syslog? ( virtual/logger )
+"
+
+GUI_RDEPEND="
+ qt5? (
+ dev-qt/qtgui:5
+ dev-qt/qtwidgets:5
+ dbus? (
+ >=dev-libs/libdbusmenu-qt5-0.9.3_pre20140619
+ dev-qt/qtdbus:5
+ )
+ kde? (
+ kde-frameworks/kconfigwidgets:5
+ kde-frameworks/kcoreaddons:5
+ kde-frameworks/knotifications:5
+ kde-frameworks/knotifyconfig:5
+ kde-frameworks/ktextwidgets:5
+ kde-frameworks/kwidgetsaddons:5
+ kde-frameworks/kxmlgui:5
+ kde-frameworks/sonnet:5
+ )
+ phonon? ( media-libs/phonon[qt5] )
+ webkit? ( dev-qt/qtwebkit:5 )
+ )
+ !qt5? (
+ dev-qt/qtgui:4
+ ayatana? ( dev-libs/libindicate-qt )
+ dbus? (
+ >=dev-libs/libdbusmenu-qt4-0.9.3_pre20140619
+ dev-qt/qtdbus:4
+ kde? (
+ kde-base/kdelibs:4
+ kde-frameworks/oxygen-icons:*
+ ayatana? ( kde-misc/plasma-widget-message-indicator )
+ )
+ )
+ phonon? ( || ( media-libs/phonon[qt4] dev-qt/qtphonon:4 ) )
+ webkit? ( dev-qt/qtwebkit:4 )
+ )
+"
+
+RDEPEND="
+ sys-libs/zlib
+ qt5? (
+ dev-qt/qtcore:5
+ dev-qt/qtnetwork:5[ssl?]
+ )
+ !qt5? ( dev-qt/qtcore:4[ssl?] )
+ monolithic? (
+ ${SERVER_RDEPEND}
+ ${GUI_RDEPEND}
+ )
+ !monolithic? (
+ server? ( ${SERVER_RDEPEND} )
+ X? ( ${GUI_RDEPEND} )
+ )
+"
+DEPEND="${RDEPEND}
+ qt5? (
+ dev-qt/linguist-tools:5
+ kde-frameworks/extra-cmake-modules
+ )
+"
+
+DOCS=( AUTHORS ChangeLog README )
+
+PATCHES=(
+ "${FILESDIR}/${P}-qt55.patch"
+ "${FILESDIR}/${P}-CVE-2015-8547.patch"
+)
+
+REQUIRED_USE="
+ || ( X server monolithic )
+ ayatana? ( || ( X monolithic ) )
+ crypt? ( || ( server monolithic ) )
+ dbus? ( || ( X monolithic ) )
+ kde? ( || ( X monolithic ) phonon )
+ phonon? ( || ( X monolithic ) )
+ postgres? ( || ( server monolithic ) )
+ qt5? ( !ayatana )
+ syslog? ( || ( server monolithic ) )
+ webkit? ( || ( X monolithic ) )
+"
+
+pkg_setup() {
+ if use server; then
+ QUASSEL_DIR=/var/lib/${PN}
+ QUASSEL_USER=${PN}
+ # create quassel:quassel user
+ enewgroup "${QUASSEL_USER}"
+ enewuser "${QUASSEL_USER}" -1 -1 "${QUASSEL_DIR}" "${QUASSEL_USER}"
+ fi
+}
+
+src_configure() {
+ local mycmakeargs=(
+ $(cmake-utils_use_find_package ayatana IndicateQt)
+ $(cmake-utils_use_find_package crypt QCA2)
+ $(cmake-utils_use_find_package crypt QCA2-QT5)
+ $(cmake-utils_use_find_package dbus dbusmenu-qt)
+ $(cmake-utils_use_find_package dbus dbusmenu-qt5)
+ $(cmake-utils_use_with kde)
+ $(cmake-utils_use_with !kde OXYGEN)
+ $(cmake-utils_use_want monolithic MONO)
+ $(cmake-utils_use_find_package phonon)
+ $(cmake-utils_use_find_package phonon Phonon4Qt5)
+ $(cmake-utils_use_use qt5)
+ $(cmake-utils_use_want server CORE)
+ $(cmake-utils_use_with webkit)
+ $(cmake-utils_use_want X QTCLIENT)
+ -DEMBED_DATA=OFF
+ -DCMAKE_SKIP_RPATH=ON
+ )
+
+ # Something broke upstream detection since Qt 5.5
+ if use ssl ; then
+ mycmakeargs+=("-DHAVE_SSL=TRUE")
+ fi
+
+ cmake-utils_src_configure
+}
+
+src_install() {
+ cmake-utils_src_install
+
+ if use server ; then
+ # needs PAX marking wrt bug#346255
+ pax-mark m "${ED}/usr/bin/quasselcore"
+
+ # prepare folders in /var/
+ keepdir "${QUASSEL_DIR}"
+ fowners "${QUASSEL_USER}":"${QUASSEL_USER}" "${QUASSEL_DIR}"
+
+ # init scripts & systemd unit
+ newinitd "${FILESDIR}"/quasselcore.init quasselcore
+ newconfd "${FILESDIR}"/quasselcore.conf quasselcore
+ systemd_dounit "${FILESDIR}"/quasselcore.service
+
+ # logrotate
+ insinto /etc/logrotate.d
+ newins "${FILESDIR}/quassel.logrotate" quassel
+ fi
+}
+
+pkg_postinst() {
+ if use monolithic && use ssl ; then
+ elog "Information on how to enable SSL support for client/core connections"
+ elog "is available at http://bugs.quassel-irc.org/wiki/quassel-irc."
+ fi
+
+ if use server; then
+ einfo "If you want to generate SSL certificate remember to run:"
+ einfo " emerge --config =${CATEGORY}/${PF}"
+ fi
+
+ if use server || use monolithic ; then
+ einfo "Quassel can use net-misc/oidentd package if installed on your system."
+ einfo "Consider installing it if you want to run quassel within identd daemon."
+ fi
+
+ # temporary info mesage
+ if use server && [[ $(get_version_component_range 2 ${REPLACING_VERSIONS}) -lt 7 ]]; then
+ echo
+ ewarn "Please note that all configuration moved from"
+ ewarn "/home/\${QUASSEL_USER}/.config/quassel-irc.org/"
+ ewarn "to: ${QUASSEL_DIR}."
+ echo
+ ewarn "For migration, stop the core, move quasselcore files (pretty much"
+ ewarn "everything apart from quasselclient.conf and settings.qss) into"
+ ewarn "new location and then start server again."
+ fi
+}
+
+pkg_config() {
+ if use server && use ssl; then
+ # generate the pem file only when it does not already exist
+ if [ ! -f "${QUASSEL_DIR}/quasselCert.pem" ]; then
+ einfo "Generating QUASSEL SSL certificate to: \"${QUASSEL_DIR}/quasselCert.pem\""
+ openssl req -x509 -nodes -days 365 -newkey rsa:2048 \
+ -keyout "${QUASSEL_DIR}/quasselCert.pem" \
+ -out "${QUASSEL_DIR}/quasselCert.pem"
+ # permissions for the key
+ chown ${QUASSEL_USER}:${QUASSEL_USER} "${QUASSEL_DIR}/quasselCert.pem"
+ chmod 400 "${QUASSEL_DIR}/quasselCert.pem"
+ else
+ einfo "Certificate \"${QUASSEL_DIR}/quasselCert.pem\" already exists."
+ einfo "Remove it if you want to create new one."
+ fi
+ fi
+}